{$R+,Q+,S+,I+}
Uses Crt, Strings, WinDos;

Procedure BHex(s: PChar; b: Byte);
Const HC: Array[0..15]Of Char = '0123456789ABCDEF';
Begin
	s[0] := HC[b Shr 4];
	s[1] := HC[b And 15];
	s[2] := #0
End;

Procedure WHex(s: PChar; w: Word);
Begin
	BHex(s+0, WordRec(w).Hi);
	BHex(s+2, WordRec(w).Lo)
End;

Procedure LHex(s: PChar; l: LongInt);
Begin
	WHex(s+0, LongRec(l).Hi);
	WHex(s+4, LongRec(l).Lo);
End;

Var
	Counter:  LongInt;

Const
	Ac=0; Zx=5; Ix=10;
	Il=1; Zy=6; Iy=11;
	Im=2; Ax=7;_In=12;
	Ab=3; Ay=8; No=13;
	Zp=4; Rl=9;Arr=14;
	(* These are the addressation methods used by 6502 CPU. *)

Function DAsm(S, A: PChar; PC: LongInt): Integer; Forward;
(* This function will disassemble a single command and *)
(* return the number of bytes disassembled.            *)

Const MN: Array[0..56]Of PChar =
(
	'adc a,','and a,','sal',    'jnc',    'jc',     'je',     'bit',    'js',
	'jne'   ,'jns'   ,'brk',    'jno',    'jo',     'clc',    'clD',    'cli',
	'clo'   ,'cmp a,','cmp x,', 'cmp y,', 'dec',    'dec x',  'dec y',  'inc x',
	'inc y' ,'xor a,','inc',    'jmp',    'call',   'mov a,', 'nop',    'mov x,',
	'mov y,','shr'   ,'or a,',  'push a', 'pushf',  'pop a',  'popf',   'rol',
	'ror'   ,'iret'  ,'ret',    'sbb a,', 'sta',    'stx',    'sty',    'stc',
	'stD'   ,'sti'   ,'mov x,a','mov y,a','mov a,x','mov a,y','mov x,s','mov s,x',
	{C64-mnemonics?}
	'arr a,'
);
{D-flag does not mean direction - it means decimal mode}

Const
	AD: Array[0..511]Of Byte =
(
	10,Il, 34,Ix, No,No, No,No, No,No, 34,Zp,  2,Zp, No,No, {0}
	36,Il, 34,Im,  2,Ac, No,No, No,No, 34,Ab,  2,Ab, No,No, {8}
	 9,Rl, 34,Iy, No,No, No,No, No,No, 34,Zx,  2,Zx, No,No, {16}
	13,Il, 34,Ay, No,No, No,No, No,No, 34,Ax,  2,Ax, No,No,
	28,Ab,  1,Ix, No,No, No,No,  6,Zp,  1,Zp, 39,Zp, No,No, {32}
	38,Il,  1,Im, 39,Ac, No,No,  6,Ab,  1,Ab, 39,Ab, No,No,
	 7,Rl,  1,Iy, No,No, No,No, No,No,  1,Zx, 39,Zx, No,No,
	47,Il,  1,Ay, No,No, No,No, No,No,  1,Ax, 39,Ax, No,No,
	41,Il, 25,Ix, No,No, No,No, No,No, 25,Zp, 33,Zp, No,No, {64}
	35,Il, 25,Im, 33,Ac, No,No, 27,Ab, 25,Ab, 33,Ab, No,No,
	11,Rl, 25,Iy, No,No, No,No, No,No, 25,Zx, 33,Zx, No,No,
	15,Il, 25,Ay, No,No, No,No, No,No, 25,Ax, 33,Ax, No,No,
	42,Il,  0,Ix, No,No, No,No, No,No,  0,Zp, 40,Zp, No,No, {96}
	37,Il,  0,Im, 40,Ac, 56,Arr,27,_In, 0,Ab, 40,Ab, No,No, {104}
	12,Rl,  0,Iy, No,No, No,No, No,No,  0,Zx, 40,Zx, No,No,
	49,Il,  0,Ay, No,No, No,No, No,No,  0,Ax, 40,Ax, No,No,
	No,No, 44,Ix, No,No, No,No, 46,Zp, 44,Zp, 45,Zp, No,No, {128}
	22,Il, No,No, 52,Il, No,No, 46,Ab, 44,Ab, 45,Ab, No,No,
	 3,Rl, 44,Iy, No,No, No,No, 46,Zx, 44,Zx, 45,Zy, No,No, {144}
	53,Il, 44,Ay, 55,Il, No,No, No,No, 44,Ax, No,No, No,No,
	32,Im, 29,Ix, 31,Im, No,No, 32,Zp, 29,Zp, 31,Zp, No,No,
	51,Il, 29,Im, 50,Il, No,No, 32,Ab, 29,Ab, 31,Ab, No,No,
	 4,Rl, 29,Iy, No,No, No,No, 32,Zx, 29,Zx, 31,Zy, No,No,
	16,Il, 29,Ay, 54,Il, No,No, 32,Ax, 29,Ax, 31,Ay, No,No, {184}
	19,Im, 17,Ix, No,No, No,No, 19,Zp, 17,Zp, 20,Zp, No,No,
	24,Il, 17,Im, 21,Il, No,No, 19,Ab, 17,Ab, 20,Ab, No,No,
	 8,Rl, 17,Iy, No,No, No,No, No,No, 17,Zx, 20,Zx, No,No,
	14,Il, 17,Ay, No,No, No,No, No,No, 17,Ax, 20,Ax, No,No,
	18,Im, 43,Ix, No,No, No,No, 18,Zp, 43,Zp, 26,Zp, No,No,
	23,Il, 43,Im, 30,Il, No,No, 18,Ab, 43,Ab, 26,Ab, No,No,
	 5,Rl, 43,Iy, No,No, No,No, No,No, 43,Zx, 26,Zx, No,No, {240}
	48,Il, 43,Ay, No,No, No,No, No,No, 43,Ax, 26,Ax, No,No
);

(** DAsm() ****************************************************)
(** This function will disassemble a single command and      **)
(** return the number of bytes disassembled.                 **)
(**************************************************************)
Function DAsm(S, A: PChar; PC: LongInt): Integer;
Var
	w: Word;
	B: PByte;
	J: Byte;
	OP: Integer;
Begin
	B := PByte(A);
	OP := (B^)*2; Inc(B);

	strcpy(s, MN[AD[OP]]);

	Case AD[OP+1]Of
		Il: ;
		Arr:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Ac: strcat(s, ' a');
		Rl:
		Begin
			J := B^; Inc(B);
			Inc(PC, 2);
			If J<$80 Then Inc(PC, J)Else Inc(PC, J-256);
			strcat(s, ' ');
			LHex(strend(s), PC)
		End;
		Im:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Zp:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, ']');
			Inc(B)
		End;
		Zx:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+x]');
			Inc(B)
		End;
		Zy:
		Begin
			strcat(s, ' [00');
			BHex(strend(s), B^);
			strcat(s, '+y]');
			Inc(B)
		End;
		Ix:
		Begin
			strcat(s, ' [word[(x+');
			BHex(strend(s), B^);
			strcat(s, ')&FF]]');
			Inc(B)
		End;
		Iy:
		Begin
			strcat(s, ' [y+word[00');
			BHex(strend(s), B^);
			strcat(s, ']]');
			Inc(B)
		End;
		Ab:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']')
		End;
		Ax:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+x]')
		End;
		Ay:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, '+y]')
		End;
		_In:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' [');
			WHex(strend(s), w);
			strcat(s, ']')
		End;
		Else
		Begin
			strcpy(s, 'db ');
			BHex(strend(s), OP Shr 1)
		End;
	End;
	If(s[0]='s')And(s[1]='t')And(s[3]<>#0)Then
	Begin
		Case s[2]Of
			'a': strcat(s, ',a');
			'x': strcat(s, ',x');
			'y': strcat(s, ',y')
		End;
		s[0] := 'm';
		s[1] := 'o';
		s[2] := 'v'
	End;
	DAsm := PChar(B) - A
End;

Function UnHex(s: PChar): LongInt; Assembler;
Asm
	les si, s
	xor ax, ax
	xor dx, dx
	xor bh, bh
@@1:
	mov bl, es:[si]
	or bl, bl
	jz @@9
	and bl, not 32
	sub bl, 16
	cmp bl, 9
	ja @@3
@@2:
	push bx
	 mov bx, 10
	 mov cx, 0
	 call LongMul
	pop bx
	add ax, bx
	adc dx, 0
	jmp @@1
@@3:
	sub bl, 39
	jmp @@2
@@9:
End;

Var
	pROM: Array[0..63]Of PChar;
	pROMCount: Integer;

	vROM: Array[0..63]Of PChar;
	vROMCount: Integer;

	fROM: Array[0..63]Of PChar;
	{bit values:}
	{ 1 = Has executable code}
	{ 2 = }
	{ 4 = }
	{ 8 = }
	{10 = }
	{20 = }
	{40 = }
	{80 = Has been read}

	Trainer: PChar;

	HasTrainer: Boolean;

	NESFlags: Word;
	Mapper: Byte;

	Pages: Array[0..15]Of Integer;

{A = AH} {X = BL} {Y = BH} {S = DL}

Procedure RdParm(s: PChar);
Var
	A1: Array[0..31]Of Char;
	w: Word;
Begin
	If s[1] = #0 Then
		Case s[0] Of
			#0: Exit;
			'A':
			Begin
				WriteLn(#9'mov al, ah');
				Exit
			End;
			'X':
			Begin
				WriteLn(#9'mov al, bl');
				Exit
			End;
			'Y':
			Begin
				WriteLn(#9'mov al, bh');
				Exit
			End;
			'S':
			Begin
				WriteLn(#9'mov al, dl');
				Exit
			End;
		End
	Else
		Case s[0] Of
			'0'..'9', 'A'..'F':
			Begin
				WriteLn(#9'mov al, 0',s,'h');
				Exit
			End;
			'[':
			Begin
				Case A1[1]Of
					'0'..'9', 'A'..'F': {nelj heksaa}
					Begin
						w := UnHex(A1+1);
						If w < $2000 Then
						Begin
							w := w And 2047;
							WriteLn(#9'mov al, byte ptr IntRAM[',w,']');
							Exit
						End;
						If w < $6000 Then
						Begin
							WriteLn(#9'mov cx, ',w);
							WriteLn(#9'call ReadPort');
							Exit
						End;
						If w < $8000 Then
						Begin
							w := w - $6000;
							WriteLn(#9'mov al, byte ptr CardRAM[',w,']');
							Exit
						End;
						If w < $C000 Then
						Begin
							WriteLn(#9'mov al, R1_',A1);
							fROM[Pages[w Shr 12]][w And $FFF] :=
							Chr(Ord(fROM[Pages[w Shr 12]][w And $FFF])Or $80);

							Exit;
						End;
					End
				End
			End
		End;
End;

Procedure Run(w: Word);
Var
	TBuf: Array[0..127]Of Char;
	MN,A1,A2: Array[0..31]Of Char;
	i, a, b: Integer;
Begin
	If Ord(fROM[Pages[w Shr 12]][w And $FFF])And 1 <> 0 Then Exit;
	{Tm on jo knnetty}

	Repeat
		i := DAsm(TBuf, pROM[Pages[w Shr 12]] + (w And $FFF), w);

		a := 0;
		b := 0;
		While Not(UpCase(TBuf[a])In[' ',#0,','])Do
		Begin
			MN[b] := UpCase(TBuf[a]);
			Inc(b);
			Inc(a)
		End;
		MN[b] := #0;

		b := 0;
		If TBuf[a] <> #0 Then While UpCase(TBuf[a])In[' ',',']Do Inc(a);
		If TBuf[a] <> #0 Then
		While Not(UpCase(TBuf[a])In[' ',#0,','])Do
		Begin
			A1[b] := UpCase(TBuf[a]);
			Inc(b);
			Inc(a)
		End;
		A1[b] := #0;

		b := 0;
		If TBuf[a] <> #0 Then While UpCase(TBuf[a])In[' ',',']Do Inc(a);
		If TBuf[a] <> #0 Then
		While Not(UpCase(TBuf[a])In[' ',#0,','])Do
		Begin
			A2[b] := UpCase(TBuf[a]);
			Inc(b);
			Inc(a)
		End;
		A2[b] := #0;

		RdParm(A2);









		Inc(w, i)
	Until False;
End;

Procedure DoIt(s: PChar);
Var
	i, a, b, l: Integer;
	Buf: Array[0..15]Of Char;
	f: File;
Begin
	Assign(f, s);
	Reset(f, 1);
	BlockRead(f, Buf, 4);
	Buf[4] := #0;
	If strcmp(Buf, 'NES'^Z) <> 0 Then
	Begin
		Close(f);
		WriteLn('Unknown format.');
		Exit
	End;
	BlockRead(f, pROMCount, 1);
	BlockRead(f, vROMCount, 1);

	pROMCount := pROMCount*4; {16kB divided into 4kB blocks}
	vROMCount := vROMCount*2; { 8kB divided into 4kB blocks}

	BlockRead(f, NESFlags, 2);
	Mapper := (Lo(NESFlags)Shr 4) + (Hi(NESFlags)And $F0);

	BlockRead(f, Buf, 8); {Should be zeroes all}
												{Not something like "diskdude"}

	HASTrainer := (NESFlags And 4 <> 0);

	If HASTrainer Then
	Begin
		GetMem(Trainer, 512);
		BlockRead(f, Trainer^, 512);
	End;

	For i := 1 To pROMCount Do
	Begin
		GetMem(pROM[i-1], 4096);
		GetMem(fROM[i-1], 4096);
		BlockRead(f, pROM[i-1]^, 4096);
		FillChar(fROM[i-1]^, 4096, 0)
	End;

	For i := 1 To vROMCount Do
	Begin
		GetMem(vROM[i-1], 4096);
		BlockRead(f, vROM[i-1]^, 4096)
	End;

	If FilePos(f) <> FileSize(f)Then
		WriteLn('Garbage after should-be file end ignored.');

	WriteLn('; File has pROM ', pROMCount*4,'kB, vROM ',vROMCount*4,'kB.');

	SwapInOut;

	Close(f);

	WriteLn('data'#9'segment word public');
	WriteLn;
	WriteLn('IntRAM'#9'db 2048 dup (?)');
	WriteLn('CardRAM'#9'db 8192 dup (?)');
	WriteLn;
	WriteLn('data'#9'ends');
	WriteLn;
	WriteLn('code'#9'segment byte public');
	WriteLn(#9'assume cs:code,ds:data,es:data,ss:pino');
	WriteLn('Start:');
	WriteLn(#9'mov ax,cs');
	WriteLn(#9'mov ds,ax');
	WriteLn(#9'mov es,ax');

	For i := 0 To 3 Do
	Begin
		Pages[ 8+i] := i;
		Pages[12+i] := i+pROMCount-4
	End;

	WordRec(i).Lo := Ord(pROM[Pages[15]][$FFC]);
	WordRec(i).Hi := Ord(pROM[Pages[15]][$FFD]);

	Run(Word(i));

	WriteLn('code'#9'ends');
	WriteLn;
	WriteLn('end'#9'Start')
End;

Var
	s: Array[0..127]Of Char;
Begin
	ClrScr;
	DirectVideo := False;

	GetArgStr(s, 1, 127);
	DoIt(s)
End.
